// Universal- Lampe LED 3 mm
 
// Variablendeklaration
 
$fn=100; //Glattheit der Radien
 
$pos=0; //legt die position des Sockels fest. 0 = Unten, 1 = rechts, 2 = Links
 
$kamin=0; //Bestimmt, ob die Lampe einen Kamin  bekommen soll, 0 = nein, 1 = Kamin
 
$loch=1; //Bestimmt, ob die Lampe ein Loch zur Montage bekommen soll, 0 = nein, 1 = Loch
 
$basis=0; //Bestimmt, ob die Lampe mit einer Basis erstellt wird, um sie vor das Gehäuse bauen zu können, 0 = nein, 1 = Ja. Kann nur mit $pos=0 zusammen verwendet werden.
 
$basisiloch=1; //Bestimmt, ob die Basis ein Loch zur Montage bekommen soll, 0 = nein, 1 = Loch Kann nur mit $pos=0 zusammen verwendet werden.
 
$t=0.0; //Toleranzwert, um den Durchmesser der Öffnung an den eigenen Drucker anzupassen. Kann positiv oder negativ sein.
 
// Konstruktion
 
// Lampenschirm
difference(){
    union(){cylinder(h=4, d=4+$t);
    translate([0,0,-1.5])cylinder(h=3.9, d=5+$t);
    }
    
    translate([0,0,-1.5])cylinder(h=9, d=3+$t);
 
    translate([0,0,-1.55])cylinder(h=2.5, d=4+$t);
       
    translate([-0.5,0,5.15])rotate([0,15,0])cube([6,6,3], true);     
}
 
// lampensockel
if($pos==0){translate([2,-2,-0.57])difference(){cube([2,4,2]);
  translate([0,3.2,-1])rotate([0,0,20])cube([3.5,2.5,4]);  
 
  translate([-0.75,-1.72,-1])rotate([0,0,-20])cube([3.6,2.5,4]);  
  
 //Loch im Lampensockel   
  if($loch==1) translate([-1,2.0,1])rotate([0,90,0])cylinder(h=25.5, d=1);
}
}
if($pos==1){translate([2,2,-0.57])rotate([0,0,90])difference(){cube([2,4,2]);
  translate([0,3.2,-1])rotate([0,0,20])cube([3.5,2.5,4]);  
 
  translate([-0.75,-1.72,-1])rotate([0,0,-20])cube([3.6,2.5,4]);  
 
 //Loch im Lampensockel   
  if($loch==1) translate([-1,2.0,1])rotate([0,90,0])cylinder(h=25.5, d=1);
 
}
}
if($pos==2){translate([-2,-2,-0.57])rotate([0,0,-90])difference(){cube([2,4,2]);
  translate([0,3.2,-1])rotate([0,0,20])cube([3.5,2.5,4]);  
 
  translate([-0.75,-1.72,-1])rotate([0,0,-20])cube([3.6,2.5,4]);  
 
 //Loch im Lampensockel   
  if($loch==1) translate([-1,2.0,1])rotate([0,90,0])cylinder(h=25.5, d=1);
 
}
}

// Kamin
if($kamin==1){translate([-3.5,0,0.53])rotate([0,90,0])cylinder(h=1.2,d=1.8,$fn=8);
 
translate([-4.4,0,0.5])rotate([0,90,0])cylinder(h=0.9,d1=0,d2=2.8);
}
 
//Lampenbasis
 
if($pos==0){if($basis==1){difference(){translate([4.3,0,-0.7])cube([1.0,4.4,5],true);
 
 //Loch in der Basis   
  if($basisiloch==1) translate([4.31,0,-25.5])rotate([0,0,0])color("pink")cylinder(h=25.5, d=0.7);
  }

}
}