// C50 Rahmen angepasst für Roco Köf 3 als Antrieb

// Variablendeklaration
$aus=0; //Variante ohne Rahmenausschnitt = 0 Variante mit Rahmenausschnitt = 1

$halling=0;//Halterung für Halling Fahrwerk erzeugen

$koef=1;//Halterung für Köf Fahrwerk erzeugen


//Modul NEM 362 Aussparung

module nem(){
 union(){
  cube([3.4,7.7,1.95]);
  translate([-0.2,7.1,0])cube([4.0,2,1.95]);    
  }
}


// Konstruktion
difference(){
    //Import der Original- STL Datei
union(){translate([89.5,-41,-14.81])import("C50_Rahmen.stl", convexity=8);
if($aus==1){
    translate([2.001,19.1,0.05])cube([1.6,3,9]);
    translate([2.001,78.1,0.05])cube([1.6,3,9]);
    translate([37.898,19.1,0.05])cube([1.6,3,9]);
    translate([37.898,78.1,0.05])cube([1.6,3,9]); 
}
}
// Vergrößerung der Aussparung im Rahmen auf das Maximum    
    translate([10.5,15.90,-1])cube([19.90,69.2,35]);
    translate([3.65,15.90,-1])cube([34.2,69.2,13.99]);
  
    //Aussparungen für NEM 362 Kupplungen
    translate([19.1,0.28,5.7])nem();
    translate([22.4,99.71,5.7])rotate([0,0,180])nem();

// Ausschnitt für Rahmen
if($aus==1){
    translate([0,23.0,-28])minkowski(){cube([49.90,54.08,35]);  
    rotate([0,90,0])cylinder(h=0.1, d=2, $fn=50);
  }
}
}  
   
if($aus==1){    
    translate([3.21,47.5,4.5])cube([2,0.8,6]);
    translate([3.21,53.5,4.5])cube([2,0.8,6]); 
    translate([2.41,47.5,4.5])cube([3,6.8,0.5]);
    
    translate([36.2,47.5,4.5])cube([2,0.8,6]);
    translate([36.2,53.5,4.5])cube([2,0.8,6]); 
    translate([35.95,47.5,4.5])cube([3,6.8,0.5]);

}

//Verschluss für Original- Kupplungsaufnahme
    translate([19.1,0.405,7.65])cube([3.4,7.7,1.95]);

    translate([19.1,91.899,7.65])cube([3.4,7.7,1.95]);

// Halterung für Halling Fahrwerk
if($halling==1){
    translate([8,17.90,12.4])cube([24.90,5,2.3]);
    
    difference(){translate([8,15.90,12.9])cube([24.90,5,1.80]);
   }
    
   difference(){translate([8,78.05,12.4])cube([24.90,7,2.3]);
   }

   translate([7.15,47.05,9.68])cube([3.90,8,3.0]);

    translate([29.4,47.05,9.68])cube([3.90,8,3.0]);

    translate([8,15.90,12.4])difference(){
    cube([24.90,71.2,2.3]);

   translate([3.0,9.5,-1])cube([18.5,49,12]);
   
   translate([-0.5,-5,-0.115])  
    cube([25.8,11.4,8.7]);

    translate([-0.5,65,-0.01])  
    cube([25.8,11.4,8.7]);

    translate([6.1,-6,-11])cube([12,7,30]);  
    
    }

 // Motor- Halterung Halling
   translate([0,1.2,0])difference(){union(){translate([9.1,34.0,14.5])      cube([2.0,31.0,7.2]);
 
   translate([29.3,34.0,14.5])cube([2.0,31.0,7.2]);

   translate([8.9,34.0,19.8]) cube([22.5,5,2]);
   
   translate([8.9,33.11,18.8]) cube([22.5,1,3]);
   
    translate([8.9,60.5,19.8]) cube([22.5,4.5,2]);

    translate([18.5,34.5,20.9]) cube([3.5,29.5,2.5]);

    translate([9.3,44.0,20.9]) cube([21.5,2.5,2.5]);

    translate([9.3,52.0,20.9]) cube([21.5,2.5,2.5]);

    translate([8.9,64.91,18.8]) cube([22.5,1,3]);
   }
    color("black")translate([8.89,33.1,14.5])cube([2.4,4,30]);

    translate([29.2,33.1,14.5])cube([2.4,4,30]);

    translate([8.89,61.92,14.5])cube([2.4,4,30]);
    
    translate([29.2,61.92,14.5])cube([2.4,4,30]);
}

}    



//Halterung für Köf Antrieb
if($koef==1){
    translate([3.9,20.70,5.1])difference(){
    cube([34.0,59,8]);
     translate([0,5.75,-0.5])cube([38,47.5,10]);
   translate([9.7,-1,-7.1])rotate([0,45,0])cube([10.5,80,10.5]);
       
    translate([-9,-0.5,-6.5])cube([20,62.5,10]);

    translate([23.5,-0.5,-6.5])cube([20,62.5,10]);
     
 }

//Brücke für die Elektronik 
 
 difference(){color("black")translate([10,20,12.5])cube([21,22.5,4]);
 color("pink")translate([13.5,15,12.4])cube([14,37.5,3]);
  }

}

 
